<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Reports">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Working with Custom Templates</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#16-reports/working-custom-templates.html">Open topic with navigation</a>
        </p>
        <h1>Working with Custom Templates</h1>
        <p><span class="VariablesProductName">Metasploit Pro</span> ships with a set of predefined standard reports, which are created with Metasploit templates and designed to meet basic pentesting reporting requirements. However, if the standard reports do not provide you with the content or layout that you need, you can use a custom template to build your report. A custom template enables you to do things like apply corporate styles to your reports, control how and where content is displayed in your reports, and customize your reports for regional compliance needs. </p>
        <p> A custom template is a JRXML file, which is an XML document with a JasperReport file extension. It contains the report structure, which defines where the report displays content, where it places images, and how it queries data. It can be built by directly manipulating XML or more easily by using a visual report tool for JasperReports, such as iReport Designer or the Eclipse-based Jaspersoft Studio. </p>
        <h2>Jasper Reports and iReport Designer</h2>
        <p><span class="VariablesProductName">Metasploit Pro</span> uses JasperReports 5.0, which is an open source Java-based reporting library, to compile JRXML templates and generate reports in output formats such as PDF, RTF, HTML, and Word. The JRXML template is a standards-based XML file that defines the elements and attributes that control where content is placed in a report. You can build the JRXML template with a visual report designer called iReport Designer, which is an open source tool maintained by Jaspersoft. </p>
        <p>iReport Designer provides a graphical user interface that enables you to visually design your report templates without extensive knowledge of the JasperReports library, XML, and Java. You can drag and drop report elements to create layout of the report, and you can connect it to a data source, like JDBC and XML, to query data for the report. The resulting JRXML template can be imported into a <span class="VariablesProductName">Metasploit Pro</span> project and used to create a custom report.</p>
        <h3>Downloading Jasper iReport</h3>
        <p>To download Jasper iReport, please visit the following site: <a href="http://jasperforge.org/projects/ireport" target="_blank" title="Download Jasper iReport" alt="Download Jasper iReport">http://jasperforge.org/projects/ireport</a>. </p>
        <h3><a name="Resources"></a>Resources for JasperReports and iReport Designer</h3>
        <p>In order to build a custom template, you must be familiar with JasperReports and iReport Designer. There are quite a few resources available that will help you learn how to build report templates with iReport Designer and understand how JasperReports works. </p>
        <p class="leadinList">To learn more about JasperReports or iReport Designer, visit the following resources:</p>
        <ul>
            <li value="1"><em>JasperReports documentation list</em> - A list of the documentation that is available for JasperStudio, JasperReports Server, JasperReports Library, and iReport Designer. You can access this list at the following URL: <a href="http://community.jaspersoft.com/documentation" target="_blank">http://community.jaspersoft.com/documentation</a>. </li>
            <li value="2"><em>JasperReports Library materials reference</em> - A list of the documentation, webinars, and articles that may be helpful for working with JasperReports. You can access this list at the following URL: <a href="http://community.jaspersoft.com/wiki/jasperreports-library-reference-materials" target="_blank">http://community.jaspersoft.com/wiki/jasperreports-library-reference-materials</a>.</li>
            <li value="3"><em>iReport Designer tutorials and help wiki</em> - A wiki that lists the tutorials  that are available for iReport&#160;Designer. You can access this list at the following URL: <a href="http://community.jaspersoft.com/wiki/ireport-designer-tutorials-help" target="_blank">http://community.jaspersoft.com/wiki/ireport-designer-tutorials-help</a>.</li>
            <li value="4"><em>An article on chart customizations</em> - A useful list of chart customizers for JasperReports, iReport Designer, and JasperReports Server. You can view this article at the following URL: <a href="http://mdahlman.wordpress.com/2011/04/17/chart-customizers-2/" target="_blank">http://mdahlman.wordpress.com/2011/04/17/chart-customizers-2/</a>.</li>
            <li value="5"><em>Groovy documentation</em> - Groovy is a Java-compatible scripting language that you can use in place of Java to define expressions in iReport. <br /><br />To learn more about how Groovy and iReport Designer work together, visit the iReport wiki here: <a href="http://http//community.jaspersoft.com/wiki/ireport-designer-groovy" target="_blank">http://http://community.jaspersoft.com/wiki/ireport-designer-groovy</a>. <br /><br />To learn more about Groovy, you can view their documentation here: <a href="http://groovy.codehaus.org/" target="_blank">http://groovy.codehaus.org/</a>.</li>
            <li value="6"><em>Jaspersoft training</em> - To learn more about Jaspersoft training, you can visit <a href="https://www.jaspersoft.com/training" target="_blank">https://www.jaspersoft.com/training-services</a> or <a href="https://www.jaspersoft.com/training" target="_blank">https://www.jaspersoft.com/training</a>. </li>
        </ul>
        <h2>
Requirements for Designing Custom Templates</h2>
        <p class="leadinList">To design a report template, you will need the following:</p>
        <ul>
            <li value="1">Experience with Jasper iReport, JasperReports, XML, and SQL/XPath</li>
            <li value="2">Experience with Java or a Java scripting language, like Groovy or Javascript</li>
            <li value="3">A working instance of Jasper&#160;iReport</li>
            <li value="4">Access to the&#160;Metasploit database</li>
        </ul>
        <h2>Setting Up the Metasploit Database in iReport Designer</h2>
        <p>To fill your report with data, you will need to set up a data source that points to the Metasploit postgres server. The information for the Metasploit postgres server can be found in <code>/path/to/metasploit/apps/pro/config/database.yml</code>. </p>
        <p class="leadinList">You will need the following information from the database.yml file:</p>
        <ul>
            <li value="1"><em>The database name</em> - The default database name is msf3.</li>
            <li value="2"><em>The postgresql port</em> - The default postgresql port is 7337. </li>
            <li value="3"><em>The user name</em> - The default user name is msf3.</li>
            <li value="4"><em>The password</em> - Please view the database.yml file for your database password.</li>
        </ul>
        <p class="leadin">To set up a data source in iReport Designer:</p>
        <ol>
            <li value="1">Open iReport Designer.<br /><br />The Quick Start window appears. <br /></li>
            <li style="text-align: left;" value="2">Click the <b class="UISelection">Database Connection</b> icon. <br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-quick-start_536x181.png" style="width: 536;height: 181;" /><br /><br />The Datasource window appears. </li>
            <li value="3">Select <b class="UISelection">Database JDBC connection</b> from the list of data sources.<br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-datasource_230x258.png" style="width: 230;height: 258;" /><br /><br /></li>
            <li value="4">Click <b class="UISelection">Next</b>. The Database JDBC&#160;Connection window appears. <br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-database-clear_276x212.png" style="width: 276;height: 212;" /><br /></li>
            <li value="5">Enter a name for the connection in the <b class="UISelection">Name</b> field. <br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-name_278x209.png" style="width: 278;height: 209;" /><br /></li>
            <li value="6">Replace with content in the  <b class="UISelection">JDBC URL</b> field with <code class="usertype">jdbc:postgresql://localhost:7337/msf3</code>.<br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-database-url_291x227.png" style="width: 291;height: 227;" /></li>
            <li style="text-align: left;" value="7">Enter the database user name in the <b class="UISelection">Username</b> field.<br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-database-username_287x212.png" style="width: 287;height: 212;" /></li>
            <li style="text-align: left;" value="8">Enter the database password in the <b class="UISelection">Password</b> field. <br /><br /><img src="../Resources/Images/reports-refactor/reports-ireport-database-password_299x219.png" style="width: 299;height: 219;" /></li>
            <li value="9">Test the connection. <br /><br />If the connection is  working properly, a window appears and alerts you that the connection was successful. <br /><br />Otherwise, if the connection fails, an exception window appears and alerts you that there is an issue with your database settings. You will need to verify that your database settings match the information in the database.yml file. </li>
            <li value="10">Save the connection, if the connection was successful. </li>
        </ol>
        <p>You are now ready to create your report template. </p>
        <p>For resources on creating report templates, see<MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Resources" class="online MCXref xref xrefonline">Resources for JasperReports and iReport Designer</a></MadCap:conditionalText>.</p>
        <h2>Custom Resources Directory</h2>
        <p>All custom templates and logos are stored in the following directory:<code> /path/to/metasploit/apps/pro/reports/custom_resources</code>.</p>
        <p>You can go to the custom resources directory to download or view logos and templates; however, you should not make any changes directly within the directory. If you need to modify your logos or templates, you should make a copy of the directory and make your changes from the new directory. </p>
        <p> Any changes that you make directly from within the custom reports directory can cause disparities between the metadata that displays for the file in the web&#160;interface and the file itself. If you need to remove or add custom resources, you should do it from within the web interface. Do not delete them directly from the custom resources directory.</p>
        <h2><a name="Uploadin"></a>Uploading Templates</h2>
        <p>After you have created your custom template, you will need to upload it to the project you want to use to build the custom report. The template will only be available to the project that you have uploaded it to; therefore, if you want to use the template across multiple projects, you will need to import the template into each project. </p>
        <p>When you view the New Custom Report form, the template will be available in the  <b class="UISelection">Report Template</b> dropdown menu. <br /></p>
        <p>
            <img src="../Resources/Images/reports-refactor/reports-custom-template-dropdown_571x178.png" style="width: 571;height: 178;" />
        </p>
        <p class="leadin">To upload a template:</p>
        <ol>
            <li value="1">Open the project you want to use to store the custom template.<br /></li>
            <li value="2">Select <b class="UISelection">Reports &gt;&#160;Create Custom Report</b> from the Project tab bar. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-report-menu_542x74.png" style="width: 542;height: 74;" /><br /><br />The <b class="UISelection">Reports</b> page appears with the Generate Custom Report tab selected. </li>
            <li value="3">Find the <b class="UISelection">Custom Report Collateral</b> area. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-report-collateral-area_544x144.png" style="width: 544;height: 144;" /><br /><br />If your project does not contain any templates, the New Custom Report page will not show the form. </li>
            <li value="4">Click the <b class="UISelection">Upload Custom Report Collateral</b> button. <br /><br /><img src="../Resources/Images/reports-refactor/reports-upload-collateral-button_547x145.png" style="width: 547;height: 145;" /><br /><br />The Upload window appears. </li>
            <li value="5">Click the <b class="UISelection">Choose File</b> button. <br /><br /><img src="../Resources/Images/reports-refactor/reports-new-custom-resource-window_317x121.png" style="width: 317;height: 121;" /><br /><br />The Open Dialog window appears. <br /></li>
            <li value="6">Browse to the location of the logo file. </li>
        </ol>
        <ol data-mc-continue="true">
            <li value="7">Select the template and click the <b class="UISelection">Open</b> button. <br /><br />The template must have a JRXML extension. </li>
            <li value="8">Enter a name for the template in the <b class="UISelection">Descriptive Name</b> field. (Optional)<br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-report-name_328x127.png" style="width: 328;height: 127;" /><br /><br />If you do not specify a name, the Custom Report&#160;Collateral area shows the original file name. </li>
            <li value="9">Click the <b class="UISelection">Submit</b> button. <br /><br />The template appears under the Custom Report Collateral area.<br /><br /> <![CDATA[ ]]><img src="../Resources/Images/reports-refactor/reports-custom-reports-area2_547x124.png" style="width: 547;height: 124;" /><br /><br />You are now ready to generate a custom report. For more information on generating custom reports, see<MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="generating-downloading-viewing-sharing-reports.html#Generati2" class="online MCXref xref xrefonline">Generating a Custom&#160;Report</a></MadCap:conditionalText>. </li>
        </ol>
        <h2>Downloading a Custom Report Template</h2>
        <ol>
            <li value="1">Open the project that contains the custom report template that you want to download. <br /></li>
            <li value="2">Select <b class="UISelection">Reports &gt;&#160;Create Custom Report</b> from the Project tab bar. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-report-menu_526x71.png" style="width: 526;height: 71;" /><br /><br />The <b class="UISelection">Reports</b> page appears with the Generate Custom Report tab selected. </li>
            <li value="3">Find the Custom Report Collateral area. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-collateral-area-1_536x102.png" style="width: 536;height: 102;" /><br /></li>
            <li value="4">Find the row that contains the custom report template you want to download. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-template-row_540x102.png" style="width: 540;height: 102;" /><br /><br />The row  displays the metadata and the actions that are available for the custom report template. </li>
            <li value="5">Click the <b class="UISelection">Download</b> link. <br /><br /><img src="../Resources/Images/reports-refactor/reports-download-custom-template_540x103.png" style="width: 540;height: 103;" /><br /><br />The download process will automatically start. <br /><br />If your browser is not configured to automatically download files, a dialog window will appear and prompt you to save or run the file. You will need to save the template to  your computer.</li>
        </ol>
        <h2>Deleting a Custom Report Template</h2>
        <ol>
            <li value="1">Open the project that contains the custom report template that you want to delete. <br /></li>
            <li value="2">Select <b class="UISelection">Reports &gt;&#160;Create Custom Report</b> from the Project tab bar. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-report-menu_542x74.png" style="width: 542;height: 74;" /><br /><br />The <b class="UISelection">Reports</b> page appears with the Generate Custom Report tab selected. </li>
            <li value="3">Find the Custom Report Collateral area. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-collateral-area-1_546x104.png" style="width: 546;height: 104;" /><br /></li>
            <li value="4">Find the row that contains the custom report template you want to delete. <br /><br /><img src="../Resources/Images/reports-refactor/reports-custom-template-row_546x104.png" style="width: 546;height: 104;" /><br /><br />The row  displays the metadata and the actions that are available for the custom report template. </li>
            <li value="5">Click the <b class="UISelection">Delete</b> link. <br /><br /><img src="../Resources/Images/reports-refactor/reports-delete-custom-template_545x103.png" style="width: 545;height: 103;" /><br /><br />The browser will prompt you to confirm that you want to delete the custom report template. </li>
        </ol>
        <h2>Downloading the Example Template</h2>
        <p><span class="VariablesProductName">Metasploit Pro</span> provides you with an example template that you can use as a reference when creating your own templates.The template provides simple examples that show you how you can query data, such as host IP addresses, names, operating systems, services counts, and vulnerabilities counts from a project, and display that information in a table. Additionally, you can see examples for adding a title and footer to the report. </p>
        <p>
            <img src="../Resources/Images/reports-refactor/reports-example-jrxml_585x363.png" style="width: 585;height: 363;" />
        </p>
        <p class="leadin">To download the example template:</p>
        <ol>
            <li value="1">Open any project. <br /></li>
            <li value="2">Select <b class="UISelection">Reports &gt;&#160;Show Reports</b> from the Project tab bar. <br /><br />The <b class="UISelection">Reports</b> page appears. </li>
            <li value="3">Scroll to the bottom of the Reports page. </li>
            <li value="4">Click the <b class="UISelection">Download Example Template</b> link, which is located below the reports table.  <br /><br /><img src="../Resources/Images/reports/reports-download-example-template_512x149.png" title="Download example template link" alt="Download example template link" style="width: 512;height: 149;" /><br /><br />The download process will automatically start. <br /><br />If your browser is not configured to automatically download files, a dialog window will appear and prompt you to save or run the file. You will need to save the report to  your computer. <br /><br /></li>
        </ol>
        <p>&#160;</p>
        <p>&#160;</p>
    </body>
</html>